%define 	pname httpd
%define 	pversion 2.2.31
%define 	bversion 103
%define 	rpmrelease iworx
%define 	contentdir /var/www
%define 	suexec_caller apache
%define 	suexec_dir /home
%define 	mmn 20051115
%define		apr_version 1.2.7
%define         mpms worker event
%define 	_default_patch_fuzz 2
%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0

%define		build_unk      1

%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	autoconf
BuildRequires:	libtool
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	autoconf
BuildRequires:	libtool
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary: 	Apache HTTP Server
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License: 	Apache License, Version 2.0

Group: 		System Environment/Daemons
Source0:	%{name}-%{version}.tar.gz
URL: 		http://httpd.apache.org/

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	Paul Oehler <poehler@interworx.com>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildRequires:	apr-devel      >= %{apr_version}
BuildRequires:	apr-util-devel >= %{apr_version}
BuildRequires:	autoconf
BuildRequires:	libtool
BuildRequires:	openldap-devel
BuildRequires:  python
Requires:	apr            >= %{apr_version}
Requires:	apr-util       >= %{apr_version}

Requires:	shadow-utils
Requires:	initscripts
Requires:	chkconfig
Requires: 	net-tools

Conflicts:      thttpd

Obsoletes:      apache
Obsoletes:	secureweb
Obsoletes:	mod_dav
Obsoletes:	httpd-suexec

Provides: 	webserver
Provides: 	httpd-mmn = %{mmn}

Source2:	ssl.conf
Source3:	httpd.init
Source4:	httpd-index.html
Source5:	httpd-apache_pb.gif
Source6:	httpd-iworx_pb.gif
Source7:	httpd-openssl_pb.gif
Source8:	httpd-php_pb.png
Source9:	httpd-interworx_logo.gif

Source10:       httpd.conf

Source12:	httpd.logrotate
Source13:       manual.conf
Source14: 	htcacheclean.init
Source15: 	htcacheclean.sysconf
Source33:	README.confd
Source35:       httpd.sysconf
Source36:       lets-encrypt.conf

Patch1:		fdsetsize4096.patch
Patch2:		httpd-2.2.22-byterange-apr_tables-inc.patch

Patch4: 	httpd-2.1.10-apctl.patch
Patch5:	 	httpd-2.1.10-apxs.patch
Patch6: 	httpd-2.2.9-deplibs.patch
Patch7:		httpd-2.1.10-disablemods.patch
Patch8: 	httpd-2.1.10-layout.patch

# Features/functional changes
Patch20: httpd-2.2.14-release.patch
Patch21: httpd-2.2.11-xfsz.patch
Patch22: httpd-2.1.10-pod.patch
Patch23: httpd-2.0.45-export.patch
Patch24: httpd-2.2.11-corelimit.patch
Patch25: httpd-2.2.11-selinux.patch
Patch26: httpd-2.2.15-sslfips.patch
Patch27: httpd-2.2.15-modreqto2217.patch
Patch28: httpd-2.2.3-mod_proxy-change-state.patch
Patch29: httpd-2.2.3-rotatelogs-trunk.patch
Patch30: httpd-2.2.3-r982629.patch
Patch31: httpd-2.2.15-proxy-failonstatus.patch
Patch32: httpd-2.2.3-ldaprefer.patch
Patch33: httpd-2.2.3-ssluserid.patch

# Bug fixes
Patch60: httpd-2.0.52-logresline.patch
Patch61: httpd-2.2.3-defpidlog.patch
Patch62: httpd-2.2.3-extfiltereos.patch
Patch63: httpd-2.2.3-graceful-ebadf.patch
Patch64: httpd-2.2.3-noxpad.patch
Patch65: httpd-2.2.3-pngmagic.patch
Patch67: httpd-2.2.14-ldapdyngrp.patch
Patch68: httpd-2.2.15-proxyconn.patch
Patch69: httpd-2.2.0-authnoprov.patch
Patch70: httpd-2.2.15-ssloidval.patch
Patch71: httpd-2.2.15-davputfail.patch
Patch72: httpd-2.2.15-expectnoka.patch
Patch73: httpd-2.2.15-pr49328.patch
Patch74: httpd-2.2.15-aboverflow.patch
Patch75: httpd-2.2.15-pr45444.patch
Patch76: httpd-2.2.15-ssldupkeys.patch
Patch77: httpd-2.2.15-ldapcache.patch
Patch78: httpd-2.2.3-pr41743.patch
Patch79: httpd-2.2.15-filterhdr.patch
Patch80: httpd-2.2.15-oomabort.patch
Patch81: httpd-2.2.15-sslpxycerts.patch
Patch82: httpd-2.2.15-sslproxyio.patch
Patch83: httpd-2.2.15-ajperror.patch
Patch84: httpd-2.2.29-sslsninotreq.patch
Patch85: httpd-2.2.15-sslbadcdev.patch
Patch86: httpd-2.2.15-proxyepsv.patch
Patch87: httpd-2.2.15-cachehardmax.patch
#Patch88: httpd-2.2.3-r965824.patch
Patch89: httpd-2.2.15-ldap-unavailable.patch
Patch90: httpd-2.2.15-ab-ssl.patch
Patch91: httpd-2.2.15-proxy-spurious-warn.patch
Patch92: httpd-2.2.15-partial-cache.patch
Patch93: httpd-2.2.15-proxyblock.patch
Patch94: httpd-2.2.3-r693108.patch
Patch95: httpd-2.2.15-ldap-auth-attrs.patch
Patch96: httpd-2.2.15-ssl-proxy-pkey.patch
Patch97: httpd-2.2.15-sslmultiproxy.patch
Patch98: httpd-2.2.15-proxy-ajp.patch
Patch99: httpd-2.2.15-ajptimeout-worker.patch
Patch100: httpd-2.2.3-r1068313.patch
Patch101: httpd-2.2.3-r1201331.patch
Patch102: httpd-2.2.15-logconfig-cookie.patch
Patch103: httpd-2.2.15-rotatelogs-condition.patch

Patch105: httpd-2.2.15-proxyvhostlog.patch
#Patch106: httpd-2.2.15-r1542327.patch
Patch107: httpd-2.2.15-apachectl-status.patch
Patch108: httpd-2.2.15-mod_ssl-reload.patch
#Patch110: httpd-2.2.15-ssl-crl-caching.patch
Patch112: httpd-2.2.15-r1530280.patch
Patch113: httpd-2.2.15-r1388547.patch
#Patch115: httpd-2.2.15-cgi-timeout.patch
Patch116: httpd-2.2.15-proxy-keepalive.patch

# Security fixes
Patch200: httpd-2.2.15-CVE-2010-1452.patch
Patch201: httpd-2.2.15-CVE-2011-3192ver3.patch
Patch203: httpd-2.2.15-CVE-2011-3348.patch
Patch204: httpd-2.2.15-CVE-2011-3607.patch
Patch205: httpd-2.2.15-CVE-2011-4317.patch
Patch206: httpd-2.2.15-CVE-2012-0031.patch
Patch207: httpd-2.2.15-CVE-2012-0053.patch
Patch208: httpd-2.2.3-CVE-2012-2687.patch
Patch209: httpd-2.2.15-CVE-2012-3499.patch
Patch210: httpd-2.2.15-CVE-2012-4558.patch
Patch211: httpd-2.2.15-CVE-2013-1862.patch

Patch300:	suexec.patch
Patch301:	harden-symlinks.patch

BuildRequires: autoconf, perl, pkgconfig, findutils
BuildRequires: zlib-devel, libselinux-devel
BuildRequires: apr-devel >= 1.2.0, apr-util-devel >= 1.2.0, pcre-devel >= 5.0
Requires: initscripts >= 8.36, /etc/mime.types, system-logos >= 7.92.1-1
Obsoletes: httpd-suexec
Requires(pre): /usr/sbin/useradd
Requires(post): chkconfig
Provides: webserver
Provides: mod_dav = %{version}-%{release}, httpd-suexec = %{version}-%{release}
Provides: httpd-mmn = %{mmn}
Obsoletes: apache, secureweb, mod_dav, mod_gzip, stronghold-apache
Obsoletes: stronghold-htdocs, mod_put, mod_roaming
Conflicts: pcre < 4.0
Requires: httpd-tools = %{version}-%{release}
#, apr-util-ldap

%description
The Apache HTTP Server is a powerful, efficient, and extensible
web server.

%package devel
Group: Development/Libraries
Summary: Development interfaces for the Apache HTTP server
Obsoletes: secureweb-devel, apache-devel, stronghold-apache-devel
Requires: apr-devel, apr-util-devel, pkgconfig
Requires: httpd = %{version}-%{release}

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for the
Apache HTTP Server.

If you are installing the Apache HTTP server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache HTTP server
Requires: httpd = %{version}-%{release}
Obsoletes: secureweb-manual, apache-manual
#BuildArch: noarch

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/2.2/.

%package tools
Group: System Environment/Daemons
Summary: Tools for use with the Apache HTTP Server

%description tools
The httpd-tools package contains tools which can be used with 
the Apache HTTP Server.

%package -n mod_ssl
Group: System Environment/Daemons
Summary: SSL/TLS module for the Apache HTTP Server
Epoch: 1
BuildRequires: openssl-devel
Requires(post): openssl >= 0.9.7f-4, /bin/cat
Requires(pre): httpd
Requires: httpd = 0:%{version}-%{release}, httpd-mmn = %{mmn}
Obsoletes: stronghold-mod_ssl

%description -n mod_ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%prep

%setup -q
%patch1 -p1
%patch2 -p1

%patch4 -p1 -b .apctl
%patch5 -p1 -b .apxs
%patch6 -p1 -b .deplibs
%patch7 -p1 -b .disablemods
%patch8 -p1 -b .layout

%patch21 -p1 -b .xfsz
%patch23 -p1 -b .export
%patch24 -p1 -b .corelimit
%patch25 -p1 -b .selinux
%patch28 -p1 -b .change-state
%patch30 -p1 -b .r982629
%patch32 -p1 -b .ldaprefer

%patch60 -p1 -b .logresline
%patch61 -p1 -b .defpidlog
%patch62 -p1 -b .extfiltereos
%patch63 -p1 -b .graceful-ebadf
%patch64 -p1 -b .noxpad
%patch65 -p1 -b .pngmagic
%patch67 -p1 -b .ldapdyngrp
%patch68 -p1 -b .proxyconn
%patch69 -p1 -b .authnoprov
%patch70 -p1 -b .ssloidval
%patch71 -p1 -b .davputfail
%patch74 -p1 -b .aboverflow
%patch76 -p1 -b .ssldupkeys
%patch80 -p1 -b .oomabort
%patch84 -p1 -b .sslsninotreq
%patch85 -p1 -b .sslbadcdev
%patch86 -p1 -b .proxyepsv
%patch87 -p1 -b .cachehardmax
#%patch88 -p1 -b .r965824
%patch90 -p1 -b .abssl
%patch93 -p1 -b .proxyblock
%patch94 -p1 -b .r693108
%patch95 -p1 -b .ldapauthattrs
%patch97 -p1 -b .sslmultiproxy
%patch100 -p1 -b .r1068313
%patch101 -p1 -b .r1201331

%patch105 -p1 -b .proxyvhostlog
#%patch106 -p1 -b .r1542327
%patch107 -p1 -b .apachectlstatus
%patch108 -p1 -b .modsslreload
#%patch110 -p1 -b .crlcaching
%patch112 -p1 -b .r1530280
%patch113 -p1 -b .r1388547
#%patch115 -p1 -b .cgitimeout
%patch116 -p1 -b .proxykeepalive

%patch300 -p1
%patch301 -p1

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# regenerate configure scripts
./buildconf

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in

%build
# forcibly prevent use of bundled apr, apr-util, pcre
rm -rf srclib/{apr,apr-util,pcre}

# regenerate configure scripts
autoheader && autoconf || exit 1

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in

CFLAGS="$RPM_OPT_FLAGS -Wformat-security -fno-strict-aliasing"
SH_LDFLAGS="-Wl,-z,relro"
export CFLAGS SH_LDFLAGS

# Forcibly disable use of rsync to install (#557049)
export ac_cv_path_RSYNC=

# Hard-code path to links to avoid unnecessary builddep
export LYNX_PATH=/usr/bin/links

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
../configure \
 	--prefix=%{_sysconfdir}/httpd \
 	--exec-prefix=%{_prefix} \
 	--bindir=%{_bindir} \
 	--sbindir=%{_sbindir} \
 	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--includedir=%{_includedir}/httpd \
	--libexecdir=%{_libdir}/httpd/modules \
	--datadir=%{contentdir} \
        --with-installbuilddir=%{_libdir}/httpd/build \
	--with-mpm=$mpm \
        --with-apr=%{_prefix} --with-apr-util=%{_prefix} \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%{suexec_caller} \
	--with-suexec-docroot=%{suexec_dir} \
	--with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
	--with-suexec-bin=%{_sbindir}/suexec \
	--with-suexec-uidmin=500 --with-suexec-gidmin=100 \
        --enable-pie \
        --with-pcre \
	$*

make %{?_smp_mflags} EXTRA_CFLAGS="-Werror-implicit-function-declaration"
popd
}

# Build everything and the kitchen sink with the prefork build
mpmbuild prefork \
        --enable-mods-shared=all \
	--enable-ssl --with-ssl \
	--enable-proxy \
        --enable-cache \
        --enable-disk-cache \
        --enable-ldap --enable-authnz-ldap \
        --enable-cgid \
        --enable-authn-anon --enable-authn-alias \
        --enable-proxy-connect \
        --enable-proxy-http \
        --enable-proxy-ftp \
        --enable-pie \
        --enable-mem-cache \
        --enable-deflate \
        --disable-imagemap

# For the other MPMs, just build httpd and no optional modules
for f in %{mpms}; do
   mpmbuild $f --enable-modules=none
done

%install

rm -rf $RPM_BUILD_ROOT

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
mv docs/man/ab.8 docs/man/ab.1
mv docs/man/logresolve.8 docs/man/logresolve.1

pushd prefork
make DESTDIR=$RPM_BUILD_ROOT install
popd

# install alternative MPMs
for f in %{mpms}; do
  install -m 755 ${f}/httpd $RPM_BUILD_ROOT%{_sbindir}/httpd.${f}
done

# install conf file/directory
mkdir $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/README.confd \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/README
for f in ssl.conf manual.conf; do
  install -m 644 -p $RPM_SOURCE_DIR/$f \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/$f
done

install -m 644 $RPM_SOURCE_DIR/lets-encrypt.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/

rm $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf/*.conf
install -m 644 -p $RPM_SOURCE_DIR/httpd.conf \
   $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf/httpd.conf

mkdir $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 644 -p $RPM_SOURCE_DIR/httpd.sysconf \
   $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/httpd
install -m 644 -p $RPM_SOURCE_DIR/htcacheclean.sysconf \
   $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/htcacheclean

# for holding mod_dav lock database
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/cache/mod_ssl
touch $RPM_BUILD_ROOT%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# create cache root
mkdir $RPM_BUILD_ROOT%{_localstatedir}/cache/mod_proxy

# move utilities to /usr/bin
mv $RPM_BUILD_ROOT%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   $RPM_BUILD_ROOT%{_bindir}

# Make the MMN accessible to module packages
echo %{mmn} > $RPM_BUILD_ROOT%{_includedir}/httpd/.mmn

# docroot
#mkdir $RPM_BUILD_ROOT%{contentdir}/html
#install -m 644 -p $RPM_SOURCE_DIR/centos_index.html \
#        $RPM_BUILD_ROOT%{contentdir}/error/noindex.html

# remove manual sources
find $RPM_BUILD_ROOT%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

# Strip the manual down just to English and replace the typemaps with flat files:
set +x
for f in `find $RPM_BUILD_ROOT%{contentdir}/manual -name \*.html -type f`; do
   if test -f ${f}.en; then
      cp ${f}.en ${f}
      rm ${f}.*
   fi
done
set -x

# Symlink for the powered-by-$DISTRO image:
ln -s ../../..%{_datadir}/pixmaps/poweredby.png \
        $RPM_BUILD_ROOT%{contentdir}/icons/poweredby.png

# Set up /var directories
rmdir $RPM_BUILD_ROOT%{_sysconfdir}/httpd/logs
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/httpd
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run/httpd

# symlinks for /etc/httpd
ln -s ../..%{_localstatedir}/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../..%{_localstatedir}/run/httpd $RPM_BUILD_ROOT/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules $RPM_BUILD_ROOT/etc/httpd/modules

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd
install -m755 $RPM_SOURCE_DIR/htcacheclean.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/htcacheclean

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 644 -p $RPM_SOURCE_DIR/httpd.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/httpd

# fix man page paths
sed -e "s|/usr/local/apache2/conf/httpd.conf|/etc/httpd/conf/httpd.conf|" \
    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
    -e "s|/usr/local/apache2/conf/magic|/etc/httpd/conf/magic|" \
    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
    -e "s|/usr/local/apache2/logs/httpd.pid|/var/run/httpd/httpd.pid|" \
    -e "s|/usr/local/apache2|/etc/httpd|" < docs/man/httpd.8 \
  > $RPM_BUILD_ROOT%{_mandir}/man8/httpd.8

# Make ap_config_layout.h libdir-agnostic
sed -i '/.*DEFAULT_..._LIBEXECDIR/d;/DEFAULT_..._INSTALLBUILDDIR/d' \
    $RPM_BUILD_ROOT%{_includedir}/httpd/ap_config_layout.h

# Fix path to instdso in special.mk
sed -i '/instdso/s,top_srcdir,top_builddir,' \
    $RPM_BUILD_ROOT%{_libdir}/httpd/build/special.mk

# Remove unpackaged files
rm -f $RPM_BUILD_ROOT%{_libdir}/*.exp \
      $RPM_BUILD_ROOT/etc/httpd/conf/mime.types \
      $RPM_BUILD_ROOT%{_libdir}/httpd/modules/*.exp \
      $RPM_BUILD_ROOT%{_libdir}/httpd/build/config.nice \
      $RPM_BUILD_ROOT%{_bindir}/ap?-config \
      $RPM_BUILD_ROOT%{_sbindir}/{checkgid,dbmmanage,envvars*} \
      $RPM_BUILD_ROOT%{contentdir}/htdocs/* \
      $RPM_BUILD_ROOT%{_mandir}/man1/dbmmanage.* \
      $RPM_BUILD_ROOT%{contentdir}/cgi-bin/*

rm -rf $RPM_BUILD_ROOT/etc/httpd/conf/{original,extra}

# Make suexec a+rw so it can be stripped.  %%files lists real permissions
chmod 755 $RPM_BUILD_ROOT%{_sbindir}/suexec

# move our test page into place
mkdir %{buildroot}%{contentdir}/html
cp %{SOURCE4} %{buildroot}%{contentdir}/html/index.html
cp %{SOURCE5} %{buildroot}%{contentdir}/html/apache_pb.gif
cp %{SOURCE6} %{buildroot}%{contentdir}/html/iworx_pb.gif
cp %{SOURCE7} %{buildroot}%{contentdir}/html/openssl_pb.gif
cp %{SOURCE8} %{buildroot}%{contentdir}/html/php_pb.png
cp %{SOURCE9} %{buildroot}%{contentdir}/html/interworx_logo.gif

%pre
# Add the "apache" user
getent group apache >/dev/null || groupadd -g 80 -r apache
getent passwd apache >/dev/null || \
  useradd -r -u 80 -g apache -s /sbin/nologin \
    -d %{contentdir} -c "Apache" apache
exit 0

%post

# Register the httpd service but only if we're a new install.  We're
# doing this because there are users who aren't running apache httpd
# as their main webserver), and we don't want it to be added to
# chkconfig unless it's a fresh install.

if [ $1 -eq 1 ] && [ -x /sbin/chkconfig ] ; then
	/sbin/chkconfig --add httpd
	/sbin/chkconfig --level 345 httpd on
	/sbin/chkconfig --add htcacheclean
fi

# Only restart httpd if it's already running.

[ -f /var/run/httpd.pid ] && [ ! -f /var/run/httpd/httpd.pid ] && mv /var/run/httpd.pid /var/run/httpd/httpd.pid || :

if [ -x /sbin/service ]; then
        for path in `find /home/ -maxdepth 2 -type l -name public_html -uid 0`; do
            user=`echo $path | sed 's/\// /g' | awk '{print $2}'`   
   	    chown -h $user.$user $path || :
	done

	httpd -t > /dev/null 2>&1
	# If the syntax is okay, then try to restart httpd.
	if [ "$?" -eq "0" ]; then
		/sbin/service httpd condrestart > /dev/null 2>&1 || :
	fi
fi

# apache default htdocs compat
if [ ! -a %{contentdir}/htdocs ]; then
	ln -fs %{contentdir}/html %{contentdir}/htdocs
fi

grep -q conf/mime.types /etc/httpd/conf/httpd.conf 2>/dev/null && sed -i 's#TypesConfig conf/mime.types#TypesConfig /etc/mime.types#' /etc/httpd/conf/httpd.conf || :

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
	/sbin/service htcacheclean stop > /dev/null 2>&1
	/sbin/chkconfig --del htcacheclean
fi

%posttrans
test -f /etc/sysconfig/httpd-disable-posttrans || \
 /sbin/service httpd condrestart >/dev/null 2>&1 || :

%define sslcert %{_sysconfdir}/pki/tls/certs/localhost.crt
%define sslkey %{_sysconfdir}/pki/tls/private/localhost.key

%post -n mod_ssl
umask 077
if [ -f %{sslkey} -o -f %{sslcert} ]; then
   exit 0
fi

if [ ! -f %{sslkey} ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{sslkey} 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{sslcert} ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{sslkey} \
         -x509 -days 365 -set_serial $RANDOM \
         -out %{sslcert} 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

%check
# Check the built modules are all PIC
if readelf -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   : modules contain non-relocatable code
   exit 1
fi

# Verify that the same modules were built into the httpd binaries
./prefork/httpd -l | grep -v prefork > prefork.mods
for mpm in %{mpms}; do
  ./${mpm}/httpd -l | grep -v ${mpm} > ${mpm}.mods
  if ! diff -u prefork.mods ${mpm}.mods; then
    : Different modules built into httpd binaries, will not proceed
    exit 1
  fi
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)

%doc ABOUT_APACHE README CHANGES LICENSE VERSIONING NOTICE

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
#%config(noreplace) %{_sysconfdir}/httpd/conf.d/welcome.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/magic
%config(noreplace) %{_sysconfdir}/httpd/conf.d/lets-encrypt.conf

%config(noreplace) %{_sysconfdir}/logrotate.d/httpd
%{_sysconfdir}/rc.d/init.d/httpd
%{_sysconfdir}/rc.d/init.d/htcacheclean

%dir %{_sysconfdir}/httpd/conf.d
%{_sysconfdir}/httpd/conf.d/README

%config(noreplace) %{_sysconfdir}/sysconfig/httpd
%config(noreplace) %{_sysconfdir}/sysconfig/htcacheclean

%{_sbindir}/ht*
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so

%dir %{contentdir}
%dir %{contentdir}/cgi-bin
%dir %{contentdir}/html
%dir %{contentdir}/icons
%dir %{contentdir}/error
%dir %{contentdir}/error/include
%{contentdir}/icons/*
%{contentdir}/error/README
#%{contentdir}/error/noindex.html
%config %{contentdir}/error/*.var
%config %{contentdir}/error/include/*.html

%attr(0710,root,apache) %dir %{_localstatedir}/run/httpd
%attr(0700,root,root) %dir %{_localstatedir}/log/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/lib/dav
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/mod_proxy

%config(noreplace) %{contentdir}/html/*

%{_mandir}/man8/*
%exclude %{_mandir}/man8/apxs.8*

%files tools
%defattr(-,root,root)
%{_bindir}/*
%{_mandir}/man1/*
%doc LICENSE

%files manual
%defattr(-,root,root)
%{contentdir}/manual
%config %{_sysconfdir}/httpd/conf.d/manual.conf

%files -n mod_ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf
%attr(0700,apache,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh

%changelog
* Thu Mar 31 2016 Tim College <tcollege@interworx.com>
- Added lets-encrypt.conf to prevent issues with certificates
* Mon Mar 14 2016 Paul Oehler <poehler@interworx.com>
- Enabled localhost access to server-status by default.
* Wed Dec 02 2015 Paul Oehler <poehler@interworx.com>
- Moved SSLProtocol and SSLCipherSuite out of ssl.conf virtualhost
  to establish a more reasonable default for these settings.
* Tue Nov 25 2015 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.2.31
* Thu May 28 2015 Paul Oehler <poehler@interworx.com>
- Added various relevant redhat patches
- httpd-2.2.15-CVE-2014-0231.patch
- httpd-2.2.15-apachectl-status.patch
- httpd-2.2.15-cgi-timeout.patch
- httpd-2.2.15-mod_proxy_http-bb-cleanup.patch
- httpd-2.2.15-mod_ssl-reload.patch
- httpd-2.2.15-proxy-keepalive.patch
- httpd-2.2.15-proxyvhostlog.patch
- httpd-2.2.15-r1388547.patch
- httpd-2.2.15-r1530280.patch
- httpd-2.2.15-r1542327.patch (logjam vuln)
- httpd-2.2.15-ssl-crl-caching.patch
* Mon Dec 08 2014 Paul Oehler <poehler@interworx.com>
- Added SSLProtocol to disable SSL2 and SSL3, re: poodle vuln
* Wed Sep 03 2014 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.2.29
* Wed Nov 20 2013 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.2.25
- Modified default SSL Cipher to exclude the bad "export" ciphers.
* Sat May 4 2013 Paul Oehler <poehler@interworx.com>
- Fixed undefined symbol: apr_lve_environment_init  
* Fri May 3 2013 Paul Oehler <poehler@interworx.com>
- Changed log permissions back from 700 to 711, as ssl_cache permission problems occured.
* Tue Mar 26 2013 Paul Oehler <poehler@interworx.com>
- Upgraded version to 2.2.24
* Tue Mar 12 2013 Matt Parmelee <mparmelee@interworx.com>
- Changed log perms from 711 to 700.
* Mon Jan 28 2013 Matt Parmelee <mparmelee@interworx.com>
- Ensured that OPENSSL_NO_DEFAULT_ZLIB was never absent.
* Wed Jan 09 2013 Matt Parmelee <mparmelee@interworx.com>
- Updated ciphers previously vulnerable to CVE-2011-3389
* Wed Aug 15 2012 Matt Parmelee <mparmelee@interworx.com>
- Added an updated logrotate script to source to prevent unnecessary restarts.
* Wed Mar 28 2012 Paul Oehler <poehler@interworx.com>
- Added apache2.2-mpm-itk-seculrelve.patch from cloud linux
- added suexec.patch from cloud linux
* Fri Feb 03 2012 Paul Oehler <poehler@interworx.com>
- Upgraded to httpd-2.2.22.
* Tue Sep 06 2011 Paul Oehler <poehler@interworx.com>
- Changed the /var/www/html/index.php file to index.html, and made it config file.
* Mon Jun 27 2011 Paul Oehler <poehler@interworx.com>
- Changed the /var/www/html/index.php interworx splash text.
* Thu Oct 21 2010 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.2.17
* Tue Aug 31 2010 Jon Daniel <jdaniel@interworx.com>
- Fixed RPM so it won't start httpd if it's not currently running,
  and it won't be added to chkconfig unless it's a new install.  This
  was done because of bug no.1559 in the interworx bug tracker.
* Tue Aug 11 2010 Paul Oehler <poehler@interworx.com>
- Added mod_ldap, mod_authn_alias, mod_authnz_ldap, and mod_file_cache, 
  for compatiblity with utterramblings repo version.
- Added rhe6x support
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Wed May 23 2007 Chris Wells <clwells@nexcess.net>
- Rebuilt for rhe5x / Apache 2.2.4
* Mon Aug 15 2005 Chris Wells <clwells@nexcess.net>
- Added ulimit to httpd init.d to bump up file handles
* Sun Sep 5 2004 Chris Wells <clwells@nexcess.net>
- Added '-DSSL' as a startup option in the init.d script
  it was missing :( and SSL no worky
- Changed ServerTokens to 'OS' from 'FULL' in the httpd.conf
- bumped to 101 release
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS

